from pybindgen import Module, FileCodeSink, param, retval, cppclass, typehandlers

def register_types(module):
    root_module = module.get_root()
    
    ## traffic-application.h: ns3::TrafficPacketFactory [class]
    module.add_class('TrafficPacketFactory', parent=root_module['ns3::Object'])
    ## traffic-application.h: ns3::CloneTrafficPacketFactory [class]
    module.add_class('CloneTrafficPacketFactory', parent=root_module['ns3::TrafficPacketFactory'])
    ## traffic-application.h: ns3::SimpleTrafficPacketFactory [class]
    module.add_class('SimpleTrafficPacketFactory', parent=root_module['ns3::TrafficPacketFactory'])
    ## traffic-application.h: ns3::TrafficApplication [class]
    module.add_class('TrafficApplication', parent=root_module['ns3::Application'])
    
    ## Register a nested module for the namespace Config
    
    nested_module = module.add_cpp_namespace('Config')
    register_types_ns3_Config(nested_module)
    
    
    ## Register a nested module for the namespace TimeStepPrecision
    
    nested_module = module.add_cpp_namespace('TimeStepPrecision')
    register_types_ns3_TimeStepPrecision(nested_module)
    
    
    ## Register a nested module for the namespace addressUtils
    
    nested_module = module.add_cpp_namespace('addressUtils')
    register_types_ns3_addressUtils(nested_module)
    
    
    ## Register a nested module for the namespace internal
    
    nested_module = module.add_cpp_namespace('internal')
    register_types_ns3_internal(nested_module)
    
    
    ## Register a nested module for the namespace olsr
    
    nested_module = module.add_cpp_namespace('olsr')
    register_types_ns3_olsr(nested_module)
    

def register_types_ns3_Config(module):
    root_module = module.get_root()
    

def register_types_ns3_TimeStepPrecision(module):
    root_module = module.get_root()
    

def register_types_ns3_addressUtils(module):
    root_module = module.get_root()
    

def register_types_ns3_internal(module):
    root_module = module.get_root()
    

def register_types_ns3_olsr(module):
    root_module = module.get_root()
    

def register_methods(root_module):
    register_Ns3TrafficPacketFactory_methods(root_module, root_module['ns3::TrafficPacketFactory'])
    register_Ns3CloneTrafficPacketFactory_methods(root_module, root_module['ns3::CloneTrafficPacketFactory'])
    register_Ns3SimpleTrafficPacketFactory_methods(root_module, root_module['ns3::SimpleTrafficPacketFactory'])
    register_Ns3TrafficApplication_methods(root_module, root_module['ns3::TrafficApplication'])
    return

def register_Ns3TrafficPacketFactory_methods(root_module, cls):
    ## traffic-application.h: ns3::TrafficPacketFactory::TrafficPacketFactory(ns3::TrafficPacketFactory const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::TrafficPacketFactory const &', 'arg0')])
    ## traffic-application.h: static ns3::TypeId ns3::TrafficPacketFactory::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## traffic-application.h: ns3::TrafficPacketFactory::TrafficPacketFactory() [constructor]
    cls.add_constructor([])
    ## traffic-application.h: ns3::Ptr<ns3::Packet> ns3::TrafficPacketFactory::CreatePacket() [member function]
    cls.add_method('CreatePacket', 
                   'ns3::Ptr< ns3::Packet >', 
                   [], 
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3CloneTrafficPacketFactory_methods(root_module, cls):
    ## traffic-application.h: ns3::CloneTrafficPacketFactory::CloneTrafficPacketFactory(ns3::CloneTrafficPacketFactory const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::CloneTrafficPacketFactory const &', 'arg0')])
    ## traffic-application.h: static ns3::TypeId ns3::CloneTrafficPacketFactory::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## traffic-application.h: ns3::CloneTrafficPacketFactory::CloneTrafficPacketFactory(ns3::Ptr<ns3::Packet> prototype=0) [constructor]
    cls.add_constructor([param('ns3::Ptr< ns3::Packet >', 'prototype', default_value='0')])
    ## traffic-application.h: void ns3::CloneTrafficPacketFactory::SetPrototype(ns3::Ptr<ns3::Packet> prototype) [member function]
    cls.add_method('SetPrototype', 
                   'void', 
                   [param('ns3::Ptr< ns3::Packet >', 'prototype')])
    ## traffic-application.h: ns3::Ptr<ns3::Packet> ns3::CloneTrafficPacketFactory::CreatePacket() [member function]
    cls.add_method('CreatePacket', 
                   'ns3::Ptr< ns3::Packet >', 
                   [], 
                   is_virtual=True)
    return

def register_Ns3SimpleTrafficPacketFactory_methods(root_module, cls):
    ## traffic-application.h: ns3::SimpleTrafficPacketFactory::SimpleTrafficPacketFactory(ns3::SimpleTrafficPacketFactory const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::SimpleTrafficPacketFactory const &', 'arg0')])
    ## traffic-application.h: static ns3::TypeId ns3::SimpleTrafficPacketFactory::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## traffic-application.h: ns3::SimpleTrafficPacketFactory::SimpleTrafficPacketFactory() [constructor]
    cls.add_constructor([])
    ## traffic-application.h: ns3::Ptr<ns3::Packet> ns3::SimpleTrafficPacketFactory::CreatePacket() [member function]
    cls.add_method('CreatePacket', 
                   'ns3::Ptr< ns3::Packet >', 
                   [], 
                   is_virtual=True)
    ## traffic-application.h: void ns3::SimpleTrafficPacketFactory::SetSize(unsigned int size) [member function]
    cls.add_method('SetSize', 
                   'void', 
                   [param('unsigned int', 'size')])
    ## traffic-application.h: unsigned int ns3::SimpleTrafficPacketFactory::GetSize() const [member function]
    cls.add_method('GetSize', 
                   'unsigned int', 
                   [], 
                   is_const=True)
    return

def register_Ns3TrafficApplication_methods(root_module, cls):
    ## traffic-application.h: ns3::TrafficApplication::TrafficApplication(ns3::TrafficApplication const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::TrafficApplication const &', 'arg0')])
    ## traffic-application.h: static ns3::TypeId ns3::TrafficApplication::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## traffic-application.h: ns3::TrafficApplication::TrafficApplication() [constructor]
    cls.add_constructor([])
    ## traffic-application.h: uint32_t ns3::TrafficApplication::GetTotalBytes() const [member function]
    cls.add_method('GetTotalBytes', 
                   'uint32_t', 
                   [], 
                   is_const=True)
    ## traffic-application.h: void ns3::TrafficApplication::DoDispose() [member function]
    cls.add_method('DoDispose', 
                   'void', 
                   [], 
                   visibility='protected', is_virtual=True)
    ## traffic-application.h: void ns3::TrafficApplication::StartApplication() [member function]
    cls.add_method('StartApplication', 
                   'void', 
                   [], 
                   visibility='private', is_virtual=True)
    ## traffic-application.h: void ns3::TrafficApplication::StopApplication() [member function]
    cls.add_method('StopApplication', 
                   'void', 
                   [], 
                   visibility='private', is_virtual=True)
    return

def register_functions(root_module):
    module = root_module
    register_functions_ns3_Config(module.get_submodule('Config'), root_module)
    register_functions_ns3_TimeStepPrecision(module.get_submodule('TimeStepPrecision'), root_module)
    register_functions_ns3_addressUtils(module.get_submodule('addressUtils'), root_module)
    register_functions_ns3_internal(module.get_submodule('internal'), root_module)
    register_functions_ns3_olsr(module.get_submodule('olsr'), root_module)
    return

def register_functions_ns3_Config(module, root_module):
    return

def register_functions_ns3_TimeStepPrecision(module, root_module):
    return

def register_functions_ns3_addressUtils(module, root_module):
    return

def register_functions_ns3_internal(module, root_module):
    return

def register_functions_ns3_olsr(module, root_module):
    return

