
set terminal pdf
set output "three-nodes-capture-3d.pdf"

set xlabel "Distance of Node 1 (m)"
set ylabel "Packet Send Time Delta (us)"
set key off

set title "Three Wireless Nodes - Reception on Node 0 of Packets from Node 1 (Moving Nearer Sender)"

set pm3d
set ticslevel 0.1
unset surface

set title 'Impossible due to CSMA/CA'
splot 'three-nodes-capture-3d.data' index 0 using 1:($2 * 1e6):3 with lines

set title 'Received Always'
splot 'three-nodes-capture-3d.data' index 1 using 1:($2 * 1e6):3 with lines

set title 'Received with Preamble Capture'
splot 'three-nodes-capture-3d.data' index 2 using 1:($2 * 1e6):3 with lines

set title 'Received with Data Capture'
splot 'three-nodes-capture-3d.data' index 3 using 1:($2 * 1e6):3 with lines

set title 'Received Total'
splot 'three-nodes-capture-3d.data' index 4 using 1:($2 * 1e6):3 with lines

set pm3d map

set title 'Impossible due to CSMA/CA'
splot 'three-nodes-capture-3d.data' index 0 using 1:($2 * 1e6):3

set title 'Received Always'
splot 'three-nodes-capture-3d.data' index 1 using 1:($2 * 1e6):3

set title 'Received with Preamble Capture'
splot 'three-nodes-capture-3d.data' index 2 using 1:($2 * 1e6):3

set title 'Received with Data Capture'
splot 'three-nodes-capture-3d.data' index 3 using 1:($2 * 1e6):3

set title 'Received Total'
splot 'three-nodes-capture-3d.data' index 4 using 1:($2 * 1e6):3

