/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
/*
 * Copyright (c) 2009 Timo Bingmann
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as 
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Author: Timo Bingmann <timo.bingmann@student.kit.edu>
 */

#ifndef NS2EXT_ERROR_RATE_MODEL_H
#define NS2EXT_ERROR_RATE_MODEL_H

#include <stdint.h>
#include "wifi-mode.h"
#include "error-rate-model.h"

namespace ns3 {

/**
 * Implements a hard-edge SINR error "rate" model for Ns2ExtWifiPhy. The
 * function GetSuccessRate() contains SINR thresholds for different wifi
 * modulations.
 */
class Ns2ExtErrorRateModel : public ErrorRateModel
{
public:
  static TypeId GetTypeId (void);

  Ns2ExtErrorRateModel ();

  virtual double GetSuccessRate (WifiMode mode, double snr) const;

  virtual double GetChunkSuccessRate (WifiMode mode, double snr, uint32_t nbits) const;
};

} // namespace ns3

#endif /* NS2EXT_ERROR_RATE_MODEL_H */
